# ory_oathkeeper_client
Documentation for all of Ory Oathkeeper's APIs.


This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.38.20-beta.1
- Build package: org.openapitools.codegen.languages.DartDioClientCodegen

## Requirements

Dart 2.7.0 or later OR Flutter 1.12 or later

## Installation & Usage

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```
name: ory_oathkeeper_client
version: 0.38.20-beta.1
description: OpenAPI API client
dependencies:
  ory_oathkeeper_client:
    git: https://github.com/ory/sdk.git
      version: 'any'
```

### Local
To use the package in your local drive, please include the following in pubspec.yaml
```
dependencies:
  ory_oathkeeper_client:
    path: /path/to/ory_oathkeeper_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:ory_oathkeeper_client/api.dart';


final api = ApiApi();

try {
    api.decisions();
} catch (e) {
    print("Exception when calling ApiApi->decisions: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApiApi* | [**decisions**](doc/ApiApi.md#decisions) | **GET** /decisions | Access Control Decision API
*ApiApi* | [**getRule**](doc/ApiApi.md#getrule) | **GET** /rules/{id} | Retrieve a Rule
*ApiApi* | [**getWellKnownJSONWebKeys**](doc/ApiApi.md#getwellknownjsonwebkeys) | **GET** /.well-known/jwks.json | Lists Cryptographic Keys
*ApiApi* | [**listRules**](doc/ApiApi.md#listrules) | **GET** /rules | List All Rules
*MetadataApi* | [**getVersion**](doc/MetadataApi.md#getversion) | **GET** /version | Return Running Software Version.
*MetadataApi* | [**isAlive**](doc/MetadataApi.md#isalive) | **GET** /health/alive | Check HTTP Server Status
*MetadataApi* | [**isReady**](doc/MetadataApi.md#isready) | **GET** /health/ready | Check HTTP Server and Database Status


## Documentation For Models

 - [GenericError](doc/GenericError.md)
 - [HealthNotReadyStatus](doc/HealthNotReadyStatus.md)
 - [HealthStatus](doc/HealthStatus.md)
 - [InlineResponse200](doc/InlineResponse200.md)
 - [InlineResponse2001](doc/InlineResponse2001.md)
 - [InlineResponse503](doc/InlineResponse503.md)
 - [JsonWebKey](doc/JsonWebKey.md)
 - [JsonWebKeySet](doc/JsonWebKeySet.md)
 - [Rule](doc/Rule.md)
 - [RuleHandler](doc/RuleHandler.md)
 - [RuleMatch](doc/RuleMatch.md)
 - [Upstream](doc/Upstream.md)
 - [Version](doc/Version.md)


## Documentation For Authorization

 All endpoints do not require authorization.


## Author

hi@ory.sh

